Package org.apache.cayenne

# Class GenericPersistentObject

java.lang.Object
org.apache.cayenne.PersistentObject
org.apache.cayenne.GenericPersistentObject

All Implemented Interfaces:
  `Serializable`, `Persistent`, `Validating`

public class GenericPersistentObject extends PersistentObject
Implementation of `Persistent` that uses `Map` to store object fields.

This implementation was pre 4.1 default.

Since 4.1 it is recommended to use `PersistentObject` as superclass (and it is actually default now), as it has better performance and lower memory consumption (much lower for small objects).

You may need to use this class only if you have some generic attributes created at runtime (also consider `HybridPersistentObject` in this case) or if any compatibility issues arise.

Since:
  5.0, renamed from CayenneDataObject
See Also:
  - `PersistentObject`
  - `HybridPersistentObject`
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected Map<String,Object>`
  `values`

  ### Fields inherited from class org.apache.cayenne.PersistentObject

  `objectContext, objectId, persistenceState, snapshotVersion`

  ### Fields inherited from interface org.apache.cayenne.Persistent

  `DEFAULT_VERSION`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `GenericPersistentObject()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `appendProperties(StringBuffer buffer)`
  `Object`
  `readPropertyDirectly(String propName)`
  Returns mapped property value as currently stored in the Persistent object.
  `protected void`
  `readState(ObjectInputStream in)`
  `void`
  `setPersistenceState(int persistenceState)`
  `void`
  `writePropertyDirectly(String propName, Object val)`
  Modifies a value of a named property without altering the object state in any way, and without triggering any database operations.
  `protected void`
  `writeState(ObjectOutputStream out)`

  ### Methods inherited from class org.apache.cayenne.PersistentObject

  `addToManyTarget, beforePropertyRead, beforePropertyWrite, getMapKey, getObjectContext, getObjectId, getPersistenceState, getSnapshotVersion, readNestedProperty, readNestedProperty, readProperty, readSerialized, removeToManyTarget, setObjectContext, setObjectId, setReverseRelationship, setSnapshotVersion, setToManyTarget, setToOneTarget, toString, toStringBuffer, unsetReverseRelationship, validateForDelete, validateForInsert, validateForSave, validateForUpdate, willConnect, writeProperty, writeSerialized`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### values

    protected Map<String,Object> values

- ## Constructor Details

  - ### GenericPersistentObject

    public GenericPersistentObject()

- ## Method Details

  - ### setPersistenceState

    public void setPersistenceState(int persistenceState)
    Specified by:
      `setPersistenceState` in interface `Persistent`
    Overrides:
      `setPersistenceState` in class `PersistentObject`

  - ### readPropertyDirectly

    public Object readPropertyDirectly(String propName)
    Description copied from interface: `Persistent`
    Returns mapped property value as currently stored in the Persistent object. Returned value maybe a fault or a real value. This method will not attempt to resolve faults, or to read unmapped properties.
    Specified by:
      `readPropertyDirectly` in interface `Persistent`
    Overrides:
      `readPropertyDirectly` in class `PersistentObject`

  - ### writePropertyDirectly

    public void writePropertyDirectly(String propName, Object val)
    Description copied from interface: `Persistent`
    Modifies a value of a named property without altering the object state in any way, and without triggering any database operations. This method is intended mostly for internal use by Cayenne framework, and shouldn't be called from the application code.
    Specified by:
      `writePropertyDirectly` in interface `Persistent`
    Overrides:
      `writePropertyDirectly` in class `PersistentObject`

  - ### appendProperties

    protected void appendProperties(StringBuffer buffer)
    Overrides:
      `appendProperties` in class `PersistentObject`

  - ### readState

    protected void readState(ObjectInputStream in) throws IOException, ClassNotFoundException
    Overrides:
      `readState` in class `PersistentObject`
    Throws:
      `IOException`
      `ClassNotFoundException`

  - ### writeState

    protected void writeState(ObjectOutputStream out) throws IOException
    Overrides:
      `writeState` in class `PersistentObject`
    Throws:
      `IOException`